import java.awt.event.*;
import java.awt.*;
import javax.swing.*;

public class EditExpense extends JPanel implements ActionListener {
 JButton jbHome;
 private int indexSelected = 1;
 private EditSplashPane jplSplash;
 private EditResultPane jplResults;
 private EditEditPane jplEditor;
 private CardLayout cards = new CardLayout();

 EditExpense() {
	super();

	setLayout(cards);

	//set up cards
	//jplSplash = new EditSplashPane();
	jplResults = new EditResultPane();
	jplEditor = new EditEditPane();

	jbHome = jplResults.jbHome;
	
	// add ActionListeners
	//jplSplash.next.addActionListener(this);
	jplResults.jbEdit.addActionListener(this);
	jplResults.jbDelete.addActionListener(this);
	jplEditor.jbSave.addActionListener(this);
	jplEditor.jbCancel.addActionListener(this);
	
	// add cards
	//add(jplSplash, "Splash");
	add(jplResults, "Results");
	add(jplEditor, "Editor");
	
	setVisible(true);	
 }  // End of Constructor
 
 @Override
 public void actionPerformed(ActionEvent evt) {
	 JButton jbSource = (JButton) evt.getSource();
	 String cardToShow = "";
	 /*
	 if(jbSource == jplSplash.next){
		 // TODO add sorting stuffs
		 jplResults.setTitles();
		 cardToShow = "Results";
		 //cards.show(this, "Card 1");
	 }
	 */
	 if(jbSource == jplResults.jbEdit) {
		 // TODO add edit stuff
		 if(jplResults.list.getSelectedIndex() == -1)
			 JOptionPane.showMessageDialog(getParent(), "Please choose an expense to edit.");
		 else{
			 indexSelected = jplResults.list.getSelectedIndex();
			 populateExpense(indexSelected);
			 cardToShow = "Editor"; 
		 }
	 }
	 if(jbSource == jplResults.jbDelete) {
		 indexSelected = jplResults.list.getSelectedIndex();
		 ExpenseIT.expenseList.remove(indexSelected);
		 ExpenseIT.expenseList.saveList(ExpenseIT.expenseList);
		 jplResults.setTitles();
		 repaint();
	 }
	 if(jbSource == jplEditor.jbCancel) {
		 cardToShow = "Results";
	 }
	 if(jbSource == jplEditor.jbSave) {
		 setExpense(indexSelected);
		 setTitles();
		 cardToShow = "Results";
	 }
	 
	 cards.show(this, cardToShow);
 }
 
 void setExpense(int index) {
	 Expense exp = new Expense(jplEditor.jtxDate.getText(), 
			 				   jplEditor.jtxCat.getText(), 
			 				   jplEditor.jtxLoc.getText(), 
			 				   jplEditor.jtxAmt.getText(), 
			 				   jplEditor.jtxNotes.getText());
	 ExpenseIT.expenseList.set(indexSelected, exp);
	 ExpenseIT.expenseList.saveList(ExpenseIT.expenseList);
 }
 void populateExpense(int index) {
	 Expense editedExpense = (Expense) ExpenseIT.expenseList.get(index);
	 jplEditor.jtxCat.setText(editedExpense.getCategory());
	 jplEditor.jtxDate.setText(editedExpense.getDate());
	 jplEditor.jtxLoc.setText(editedExpense.getLocation());
	 jplEditor.jtxAmt.setText(editedExpense.getAmount());
	 jplEditor.jtxNotes.setText(editedExpense.getNotes());
 }
 void setTitles() {
	 jplResults.setTitles();
 }
}

class EditSplashPane extends JPanel {
 JLabel banner;
 JLabel sortLabel;
 JTextField category, date, location;
 JButton next, jbBack;
 
 EditSplashPane() {
	 super();
	 setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));
	 banner = new JLabel("Edit and Existing Expense");
	 Dimension textFieldSize = new Dimension(1000, 30);
	 
	 JPanel comboHolder = new JPanel();
	 comboHolder.setLayout(new BoxLayout(comboHolder, BoxLayout.PAGE_AXIS));
	 sortLabel = new JLabel("Sort by:");
	 category = new JTextField("Category: ");	// TODO replace with a combobox that has all categories
	 date = new JTextField("Date:");			// TODO replace with a combobox that has all dates
	 location = new JTextField("Location:");	// TODO replace with a combobox that has all locations

	 category.setMaximumSize(textFieldSize);
	 date.setMaximumSize(textFieldSize);
	 location.setMaximumSize(textFieldSize);
	 comboHolder.add(sortLabel);
	 comboHolder.add(Box.createVerticalStrut(10));
	 comboHolder.add(category);
	 comboHolder.add(Box.createVerticalStrut(8));
	 comboHolder.add(date);
	 comboHolder.add(Box.createVerticalStrut(8));
	 comboHolder.add(location);
	 
	 JPanel buttonHolder = new JPanel();
	 next = new JButton("Search");
	 jbBack = new JButton("Back");
	 buttonHolder.add(next);
	 buttonHolder.add(jbBack);
	 
	 add(banner);
	 add(Box.createVerticalStrut(30));
	 add(comboHolder);
	 add(Box.createVerticalGlue());
	 add(buttonHolder);
 }
}

class EditResultPane extends JPanel {
 JButton jbEdit, jbDelete, jbHome;
 JList list;
 JLabel jlHeaders;
 DefaultListModel titles = new DefaultListModel();
 
 EditResultPane() {
	 super();
	 
	 String sortHeaders = "Date  ::  Category  ::  Location  ::  Amount";
	 jlHeaders = new JLabel(sortHeaders);
	 	
	 setTitles();
	 list = new JList(titles);
	 list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	 list.setLayoutOrientation(JList.VERTICAL);
	 list.setSelectedIndex(0);
	 
	 JScrollPane listScroller = new JScrollPane(list);
	 listScroller.setPreferredSize(new Dimension(300, 300));
	 
	 jbDelete = new JButton("Delete");
	 jbEdit = new JButton("Edit");
	 jbHome = new JButton("Home");
	 
	 add(jlHeaders);
	 add(listScroller);
	 add(jbEdit);
	 add(jbDelete);
	 add(jbHome);
 }
 
 public void setTitles() {
	 titles.clear();
	 for(int i = 0; i < ExpenseIT.expenseList.size(); ++i){
		 Expense exp = (Expense) ExpenseIT.expenseList.elementAt(i);
		 String title = (exp.getDate() + " :: " + exp.getCategory() + " :: " 
				 + exp.getLocation() + " :: " + exp.getAmount());
		 titles.addElement(title);
	 }
 }
}

class EditEditPane extends JPanel {
 JButton jbSave, jbCancel;
 JTextField jtxCat, jtxDate, jtxLoc, jtxAmt;
 JTextArea jtxNotes;
 Dimension textFieldSize = new Dimension(1000, 30);
 
 EditEditPane() {
	 super();
	 setLayout(new BorderLayout());
	 
	 JPanel buttonHolder = new JPanel();
	 buttonHolder.setLayout(new BoxLayout(buttonHolder, BoxLayout.LINE_AXIS));
	 jbSave = new JButton("Save");
	 jbCancel = new JButton("Cancel");
	 buttonHolder.add(Box.createHorizontalGlue());
	 buttonHolder.add(jbCancel);
	 buttonHolder.add(jbSave);
	 
	 JPanel editHolder = new JPanel();
	 editHolder.setLayout(new BoxLayout(editHolder, BoxLayout.PAGE_AXIS));
	 jtxCat = new JTextField("Category");
	 jtxCat.setMaximumSize(textFieldSize);
	 jtxDate = new JTextField("Date");
	 jtxDate.setMaximumSize(textFieldSize);
	 jtxLoc = new JTextField("Location");
	 jtxLoc.setMaximumSize(textFieldSize);
	 jtxAmt = new JTextField("$Amount");
	 jtxAmt.setMaximumSize(textFieldSize);
	 jtxNotes = new JTextArea("Notes:", 2, 8);
	 JScrollPane scrollPane = new JScrollPane(jtxNotes);
	 editHolder.add(Box.createVerticalStrut(5)); // puts a vertical spacer
	 editHolder.add(jtxCat);
	 editHolder.add(Box.createVerticalStrut(5)); // puts a vertical spacer
	 editHolder.add(jtxDate);
	 editHolder.add(Box.createVerticalStrut(5)); // puts a vertical spacer
	 editHolder.add(jtxLoc);
	 editHolder.add(Box.createVerticalStrut(5)); // puts a vertical spacer
	 editHolder.add(jtxAmt);
	 editHolder.add(Box.createVerticalStrut(5)); // puts a vertical spacer
	 editHolder.add(scrollPane);
	 
	 add(buttonHolder, BorderLayout.PAGE_START);
	 add(editHolder, BorderLayout.CENTER);
 }
}