import java.awt.event.*;
import java.io.*;

import javax.swing.*;

public class ExpenseIT extends JFrame implements ActionListener {
 JLabel banner, vLabel;
 JButton jbAdd, jbEdit, jbSettings;
 JPanel master, home;
 AddExpense addPane;
 EditExpense editPane;
 public static ExpenseList expenseList;
	
 ExpenseIT() {
	 super("ExpenseIT");
	 setSize(320, 480);
	 setLocation(400, 250);
	 setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	 
	 // Set the list to a previous list if it exists or the default if not
	 loadList();

	 
	 banner = new JLabel("Welcome to ExpenseIT!");
	 jbAdd = new JButton("Add Expense");
	 jbEdit = new JButton("Edit Expense");
	 jbSettings = new JButton("Settings");
	 vLabel = new JLabel("Version 0.1");
	 
	 home = new JPanel();
	 home.setLayout(new BoxLayout(home, BoxLayout.PAGE_AXIS));
	 home.add(Box.createVerticalStrut(10));
	 home.add(banner);
	 home.add(Box.createVerticalStrut(20));
	 home.add(jbAdd);
	 home.add(Box.createVerticalStrut(10));
	 home.add(jbEdit);
	 home.add(Box.createVerticalStrut(10));
	 home.add(jbSettings);
	 home.add(Box.createVerticalGlue());
	 home.add(vLabel);
	 
	 addPane = new AddExpense();
	 editPane = new EditExpense();
	 
	 jbAdd.addActionListener(this);
	 jbEdit.addActionListener(this);
	 jbSettings.addActionListener(this);
	 addPane.jbHome.addActionListener(this);
	 editPane.jbHome.addActionListener(this);
	 
	 setContentPane(home);
	 setVisible(true);
 }
	
 @Override
 public void actionPerformed(ActionEvent evt) {
	 JButton jbSource = (JButton) evt.getSource();
	 
	 // Access the AddExpense Class
	 if(jbSource == jbAdd) {
		 setContentPane(addPane);
		 setVisible(true);
		 repaint();
	 }
	 if(jbSource == addPane.jbHome) {
		 setContentPane(home);
		 setVisible(true);
		 repaint();
	 }
	 
	 // Access the EditExpense Class
	 if(jbSource == jbEdit) {
		 editPane.setTitles();
		 setContentPane(editPane);
		 setVisible(true);
		 repaint();
	 }
	 if(jbSource == editPane.jbHome) {
		 setContentPane(home);
		 setVisible(true);
		 repaint();
	 }
	 
 }
 
 public void loadList() {
	 File file = new File("ExpenseIT.dat");
	 // if there's a list already saved in ExpenseIT.dat - load that list
	 if(file.exists()) {
		 try {
			 FileInputStream fi = new FileInputStream("ExpenseIT.dat");
			 ObjectInputStream oi = new ObjectInputStream(fi);
			 expenseList = (ExpenseList) oi.readObject();
			 // TODO add some testing to ensure list is viable
			 oi.close();
		 } catch (Exception e) {
			 System.out.println("Error - " + e.toString());
		 }
	 } 
	 // if no previous list exists (there's no file) then setup a new default list
	 else { 
		 expenseList = new ExpenseList();
	 }
 }
 
 public static void main(String[] args) {
	new ExpenseIT();
 }
}