/*****************************
 ** Date: 3/03/11			**
 * Programmer: Garry Burns
 * Project Name: ExpenseIT
 * Parent File Names: EditExpense.java, AddExpense.java, ExpenseList.java
 * Referenced Files: none
 *****************************
 ** Class Version: 1.0		**
 ** Change Log:				**
 * 03/03/2011	Class Created
 * 
 *****************************
 ** Notes:					** 
 * Each instance of this class represents an individual expense. It contains 
 * all the information required. For ease and portability all fields are stored
 * as strings.
 * 
 *****************************
 ** Things TODO:			**
 * 1. Add controls to ensure that input strings conform to the data models
 * 		and are saved in the appropriate formats as in - 
 * 		date is in format MM/DD/YYYY (or acceptable alternative)
 * 		amounts are saved to the hundredth (Amount = DDD.cc)
 * 2. Review Code and clean up and streamline as necessary
 */


import java.io.Serializable;

@SuppressWarnings("serial")
public class Expense implements Serializable {
 private String date, category, location, amount, notes;
 // Constructor
 Expense() {};
 Expense(String inDate, String inCat, String inLoc, String inAmt, String inNotes) {
	 date = inDate;
	 category = inCat;
	 location = inLoc;
	 amount = inAmt;
	 notes = inNotes;
 }

 /********************
  ** Access methods **
  ********************/
 
 // set information
 public void setDate(String inDate) {
	 date = inDate;
 }
 public void setCategory(String inCat) {
	 category = inCat;
 }
 public void setLocation(String inLoc) {
	 location = inLoc;
 }
 public void setAmount(String inAmt) {
	 amount = inAmt;
 }
 public void setNotes(String inNotes) {
	 notes = inNotes;
 }
 
 // read information
 public String getDate() {
	 return date;
 }
 public String getCategory() {
	 return category;
 }
 public String getLocation() {
	 return location;
 }
 public String getAmount() {
	 return amount;
 }
 public String getNotes() {
	 return notes;
 }
}
