/**
 * Date: 3/03/11
 * Programmer: Garry Burns
 * Project Name: ExpenseIT
 * Parent File Names: EditExpense.java, AddExpense.java
 * Referenced Files: 
 * 			Expense.java
 * 
 * Class Version: 1.0
 * Change Log:
 * 03/03/2011	Class Created
 * 
 * Notes: 
 * This class is used to store the expenses as they are created. 
 * It can write itself to a file so the created list will persist.
 * 
 * Things TODO:
 * 1. Review Code and clean up and streamline as necessary
 */


import java.io.*;
import javax.swing.DefaultListModel;


public class ExpenseList extends DefaultListModel implements Serializable {

 /**
  * serialVersionUID was setup automatically by eclipse
  */
	private static final long serialVersionUID = 1L;
// Create a brand new expense list
 ExpenseList(){
	super();
	Expense demoExp1 = new Expense("03/11/2011", 
				"Office Supplies", 
				"Office Depot", 
				"85.00", 
				"Pense, pencils, etc.");
	Expense demoExp2 = new Expense("03/15/2011", 
				"Dining", 
				"Maki Zushi", 
				"158.00",
				"Cleveland Clients");
	Expense demoExp3 = new Expense("03/12/2011",
				"Office Supplies",
				"Costco",
				"230.00",
				"Printing supplies, bathroom & cleaning supplies");
	Expense demoExp4 = new Expense("02/15/2010",
			"Entertainment",
			"The Yardhouse",
			"455.00",
			"Birthday Celebrations");

	addElement(demoExp1);
	addElement(demoExp2);
	addElement(demoExp3);
	addElement(demoExp4);
	
	saveList(this);
 }
 
 public void saveList(ExpenseList list) {
	 try {
		 FileOutputStream fo = new FileOutputStream("ExpenseIT.dat");
		 ObjectOutputStream oo = new ObjectOutputStream(fo);
		 oo.writeObject(list);
		 oo.close();
	 } catch (IOException e) {
		 System.out.println("Error - " + e.toString());
	 }
 }
 public ExpenseList getList() {
	 ExpenseList list;
	 try {
		 FileInputStream fi = new FileInputStream("ExpenseIT.dat");
		 ObjectInputStream oi = new ObjectInputStream(fi);
		 list = (ExpenseList) oi.readObject();
		 // TODO add some testing to ensure list is viable
		 oi.close();
		 return list;
	 } catch (Exception e) {
		 System.out.println("Error - " + e.toString());
		 return null;
	 }
 }
}
