/**
 * Date: 3/10/11
 * Programmer: Garry Burns
 * Project Name: ExpenseIT
 * Version: 0.2.4
 * Parent File Names: EditExpense.java
 * Referenced Files: 
 * 			CategoryList.java
 * 
 * Class Version: 0.1
 * Change Log:
 * 03/10/2011	Class Created
 * 
 * Notes: 
 * SettingsPane consists of a menu where mutable options can be adjusted.
 * 
 * Things TODO:
 */
package com.garryburns.ExpenseIT;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

@SuppressWarnings("serial")
public class SettingsPane extends JPanel implements ActionListener {
 JButton jbExitSettings;
 private static JPanel jplHome;
 private static JButton[] jbSettings;
 private static JLabel jlbBanner;
 private static CardLayout cards = new CardLayout();
 private static EditCatsPane jplCatsEditor;
 private static final Dimension buttonSize = new Dimension(270,30);
 private static final int USER = 0, COMP = 1,  SYNC = 2, CAT = 3, LOC = 4, SKIN = 5, SETVERSION =6;
 
 SettingsPane() {
	 super();
	 setLayout(cards);
	 jplHome = new JPanel();
	 jplCatsEditor = new EditCatsPane(); 
	 

	 EditCatsPane.jbBack.addActionListener(this);
	 
	 jlbBanner = new JLabel("Settings");
	 Font f = new Font(Font.DIALOG, Font.BOLD, 15);
	 jlbBanner.setFont(f);
	 jplHome.add(Box.createRigidArea(buttonSize));
	 jplHome.add(jlbBanner);
	 jplHome.add(Box.createRigidArea(buttonSize));
	 
	 loadButtons();
	 
	 add(jplHome, "HOME");
	 add(jplCatsEditor, "CATS");
	 
	 setVisible(true);
 } //End Constructor
 
 @Override
 public void actionPerformed(ActionEvent e) {
	 JButton jbSource = (JButton) e.getSource();
 
	 if(jbSource == EditCatsPane.jbBack){
		 cards.show(this, "HOME");
		 return;
	 }
	 else {
		 int actionCommand = Integer.parseInt(jbSource.getActionCommand());
		 switch (actionCommand) 
		 {
	 		case USER: 
	 				comingSoon();
		 			break; 
		 	case COMP: 
		 			comingSoon();
		 			break;
		 	case SYNC:
		 			comingSoon();
	 				break;
		 	case CAT: 
		 			cards.show(this, "CATS");
		 			break;
		 	case LOC:
		 			comingSoon();
		 			break;
		 	case SKIN:
		 			comingSoon();
		 			break;
		 	case SETVERSION:
		 			askForAuthentication();
		 	default: break;
		 }
	 }
 }
 
 private void comingSoon() {
	JOptionPane.showMessageDialog(getParent(), "This feature is coming soon",
						"Feature Coming Soon",
						JOptionPane.INFORMATION_MESSAGE);	
}

private void askForAuthentication() {
		String input = (String)JOptionPane.showInputDialog(
					getParent(),
					"Please enter your authentication code:"
					+ "\nLite: lite"
					+ "\nPersonal: personal"
					+ "\nProfessional: professional",
					"Upgrade Version",
					JOptionPane.PLAIN_MESSAGE,
					null,
					null,
     				"personal");
		if ((input != null) && (input.length() > 0)) {
			ExpenseIT.settings.setAuthenticationCode(input);
			Settings.saveSettings(ExpenseIT.settings);
			JOptionPane.showMessageDialog(getParent(), "Please restart application for changes to take affect");
         return;
     }
 }
 private String[] setButtonString() {
	 if(ExpenseIT.versionCode.equals("professional")) {
		 String[] buttonNames = {"User Settings", "Company Settings", "Sync Options", "Edit Categories", 
				 				"Saved Locations", "Change Skin", "Upgrade Version"};
		 return buttonNames;
	 }
	 else {
		 String[] buttonNames = {"Edit Categories", "Saved Locations", "Change Skin", "Upgrade Version"}; 
		 return buttonNames;
	 }
 }
 private void loadButtons() {
	 String[] actionCommands = {"0", "1", "2", "3", "4", "5", "6"};
	 String[] buttonNames = setButtonString();
	 jbSettings = new JButton[buttonNames.length];
	 for(int i = 0; i < buttonNames.length; ++i) {
		 jbSettings[i] = new JButton(buttonNames[i]);
		 jbSettings[i].setPreferredSize(buttonSize);
		 if(buttonNames.length == 7)
			 jbSettings[i].setActionCommand(actionCommands[i]);
		 else
			 jbSettings[i].setActionCommand(actionCommands[i+3]);
		 jbSettings[i].addActionListener(this);
		 jplHome.add(jbSettings[i]);
	 }
	 jplHome.add(Box.createRigidArea(new Dimension(300,10)));
	 jbExitSettings = new JButton("Back");
	 jplHome.add(jbExitSettings);
	 
	 if(ExpenseIT.versionCode.equals("lite")) {
		 int j = 0;
		 while(j < buttonNames.length - 1) {
			 jbSettings[j].setEnabled(false);
			 j++;
		 }
	 }
 }

 public void setTitles() {
	jplCatsEditor.setTitles();	
 }
}

@SuppressWarnings("serial")
class EditCatsPane extends JPanel implements ActionListener {
 private static JButton jbAdd, jbEdit, jbDelete, jbUndo, jbDefaultCats;
 static JButton jbBack;
 private static JList list;
 private static DefaultListModel catNames;
 private static int indexSelected, indexDeleted;
 private static Category deletedCat;
 
 EditCatsPane() {
	super();
	
	jbAdd = new JButton("Add");
	jbEdit = new JButton("Edit");
	jbDelete = new JButton("Delete");
	jbUndo = new JButton("Undo");
	jbUndo.setEnabled(false);
	jbBack = new JButton("Back");
	jbDefaultCats = new JButton("Default List");
	
	jbAdd.addActionListener(this);
	jbEdit.addActionListener(this);
	jbDelete.addActionListener(this);
	jbUndo.addActionListener(this);
	jbDefaultCats.addActionListener(this);
	
	catNames = new DefaultListModel();
	setTitles();
		
	list = new JList(catNames);
	list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	list.setLayoutOrientation(JList.VERTICAL);
	list.setSelectedIndex(0);
	JScrollPane listScroller = new JScrollPane(list);
	listScroller.setPreferredSize(new Dimension(310, 300)); 
	
	add(listScroller);
	add(jbAdd);
	add(jbEdit);
	add(jbDelete);
	add(jbUndo);
	add(jbBack);
	add(jbDefaultCats);
 }

 @Override
 public void actionPerformed(ActionEvent evt) {
	JButton jbSource = (JButton) evt.getSource();
	
	if(jbSource == jbAdd) {
		addCat();
	}
	if(jbSource == jbEdit) {
		editCat();
	}
	if(jbSource == jbDelete) {
		deleteCat();
		enableDelete();
	}
	if(jbSource == jbUndo) {
		undoDelete();
	}
	if(jbSource == jbDefaultCats) {
		resetCategories();
	}
 }
 private void resetCategories() {
	ExpenseIT.categoriesList = new CategoriesList();
	setTitles();
	enableDelete();
	jbUndo.setEnabled(false);
	repaint();
}

private void addCat() {
	 String name = JOptionPane.showInputDialog(getParent(), "Enter a new Category");
	 if ((name != null) && (name.length() > 0)) {
		 ExpenseIT.categoriesList.addCategory(name);
		 setTitles();
		 list.setSelectedIndex(catNames.getSize()-1);
		 repaint();
    }
 }
 private void editCat() {
	indexSelected = list.getSelectedIndex();
	//TODO create a custom dialog where the cancel simply returns to the cat list (currently it deletes
	// any category that was selected to be edited but then the user presses cancel.
	String input = JOptionPane.showInputDialog(getParent(), 
										"Enter a new name", 
										((Category) ExpenseIT.categoriesList.get(indexSelected)).getName());
	 if ((input != null) && (input.length() > 0)) {
		 ((Category) ExpenseIT.categoriesList.get(indexSelected)).setName(input);
		 CategoriesList.saveList(ExpenseIT.categoriesList);
		 setTitles();
		 list.setSelectedIndex(indexSelected);
		 repaint();
    }
 }
private void deleteCat() {
	 //Delete the selected category then show the new list
	 indexSelected = list.getSelectedIndex();
	 deletedCat = (Category) ExpenseIT.categoriesList.remove(indexSelected);	//Remove Expense and store in case of undo
	 indexDeleted = indexSelected;				//Save the deleted expense's index
	 CategoriesList.saveList(ExpenseIT.categoriesList);
	 jbUndo.setEnabled(true);
	 setTitles();
	 if(indexSelected < catNames.getSize())
		 list.setSelectedIndex(indexSelected);
	 else list.setSelectedIndex(indexSelected - 1);
	 repaint();
 }
void setTitles() {
	catNames.clear();
	for(int i = 0; i < ExpenseIT.categoriesList.getSize(); ++i)
		catNames.add(i, ((Category) ExpenseIT.categoriesList.get(i)).getName());
 }
 private void enableDelete() {
	if(catNames.getSize() < 1)				//Disable Delete if there's nothing to delete
		jbDelete.setEnabled(false);
	else
		jbDelete.setEnabled(true);
 }
 private void undoDelete() {
	 jbUndo.setEnabled(false);
	 ExpenseIT.categoriesList.add(indexDeleted, deletedCat);
	 CategoriesList.saveList(ExpenseIT.categoriesList);
	 setTitles();
	 list.setSelectedIndex(indexDeleted);
	 enableDelete();
	 repaint();
 }
}