/*package com.garryburns.ExpenseIT;

import java.awt.*;
import java.awt.event.*;
import java.util.Date;
import java.util.EventListener;
import java.util.Vector;

import javax.swing.*;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.DefaultTableModel;

@SuppressWarnings("serial")
class EditCatsPaneAlternate extends JPanel implements ActionListener, TableModelListener {
 private static JButton jbAdd, jbDelete, jbUndo, jbDefaultCats;
 static JButton jbBack;
 private static DefaultListModel catNames;
 private static int indexSelected, indexDeleted;
 private static Category deletedCat;
 MyTableModel tableData = new MyTableModel();
 JTable table;
 
 EditCatsPaneAlternate() {
	super();
	
	jbAdd = new JButton("Add");
	jbDelete = new JButton("Delete");
	jbUndo = new JButton("Undo");
	jbUndo.setEnabled(false);
	jbBack = new JButton("Back");
	jbDefaultCats = new JButton("Default List");
	
	jbAdd.addActionListener(this);
	jbDelete.addActionListener(this);
	jbUndo.addActionListener(this);
	jbDefaultCats.addActionListener(this);
	
	catNames = new DefaultListModel();
	 
	table = new JTable(tableData);
	table.setPreferredScrollableViewportSize(new Dimension(300, 300));
    table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	table.setFillsViewportHeight(true);
	JScrollPane scroller = new JScrollPane(table);
	
	add(scroller);
	add(jbAdd);
	add(jbDelete);
	add(jbUndo);
	add(jbBack);
	add(jbDefaultCats);
 }

 @Override
 public void actionPerformed(ActionEvent evt) {
	JButton jbSource = (JButton) evt.getSource();
	
	if(jbSource == jbAdd) {
		addCat();
	}
	if(jbSource == jbDelete) {
		deleteCat();
		enableDelete();
	}
	if(jbSource == jbUndo) {
		undoDelete();
	}
	if(jbSource == jbDefaultCats) {
		resetCategories();
	}
 }
 private void resetCategories() {
	ExpenseIT.categoriesList = new CategoriesList();
	tableData = new MyTableModel();
	table.setModel(tableData);
	enableDelete();
	jbUndo.setEnabled(false);
	repaint();
}

 private void addCat() {
	 String name = JOptionPane.showInputDialog(getParent(), "Enter a new Category");
	 if ((name != null) && (name.length() > 0)) {
		 ExpenseIT.categoriesList.addCategory(name);
		 Object[] catO = {name, false};
		 tableData.addRow(catO);
	 }
 }
   
   
private void deleteCat() {
	 //Delete the selected category then show the new list
	 indexSelected = table.getSelectedRow();
	 
	 //Remove Expense and store in case of undo
	 deletedCat = (Category) ExpenseIT.categoriesList.remove(indexSelected);
	 indexDeleted = indexSelected;
	 CategoriesList.saveList(ExpenseIT.categoriesList);

     tableData.removeRow(indexSelected);
     setRow(indexSelected);
	
	 jbUndo.setEnabled(true);
	 repaint();
 }
 private void setRow(int row) {
	if(row > 0 && row < tableData.getRowCount())
		table.setRowSelectionInterval(row, row);
	else 
		table.setRowSelectionInterval(0, 0);
	
 }

 private void enableDelete() {
	if(tableData.getRowCount() < 1)				//Disable Delete if there's nothing to delete
		jbDelete.setEnabled(false);
	else
		jbDelete.setEnabled(true);
 }
 private void undoDelete() {
	 jbUndo.setEnabled(false);
	 int defaultCount = 0;
	 for(int i = 0; i < ExpenseIT.categoriesList.size(); ++i){
		 Category cat = (Category) ExpenseIT.categoriesList.get(i);
		 if(cat.getIsDefault())
			 defaultCount++;
	 }
	 if(defaultCount >= 4)
		 deletedCat.setIsDefault(false);
	 ExpenseIT.categoriesList.add(indexDeleted, deletedCat);
	 CategoriesList.saveList(ExpenseIT.categoriesList);
	 Object[] catO = {deletedCat.getName(), deletedCat.getIsDefault()};
	 
	 tableData.insertRow(indexDeleted, catO);
	 setRow(indexDeleted);
	 enableDelete();
	 repaint();
 }

@Override
public void tableChanged(TableModelEvent e) {
	table.tableChanged(new TableModelEvent(
			tableData, tableData.getRowCount(), tableData.getRowCount(), TableModelEvent.ALL_COLUMNS, 
			 TableModelEvent.INSERT));
	table.repaint();
}
}

@SuppressWarnings("serial")
class MyTableModel extends DefaultTableModel {
 private static String[] cols = {"Category Name", "Default"};
 Vector<?> data = this.getDataVector();
	
 MyTableModel() {
	super(null, cols);
	
	 for(int i = 0; i < ExpenseIT.categoriesList.size(); ++i) {
		 Category cat = (Category) ExpenseIT.categoriesList.get(i);
		 Object[] catO = {cat.getName(), cat.getIsDefault()};
		 this.addRow(catO);
	 }
}
	
 @Override
 public boolean isCellEditable(int row, int column) {
	return true;
 }
 @Override
 public Class<?> getColumnClass(int c) {
	return getValueAt(0, c).getClass();
 }
 @Override
 public void setValueAt(Object value, int nRow, int nCol) {
    if (nRow < 0 || nRow>=getRowCount())
      return;
    Category row = (Category) ExpenseIT.categoriesList.get(nRow); // (Category)data.get(nRow);
    Vector thing = (Vector) data.elementAt(nRow);
    
    switch (nCol) {
      case 0: 
    	  thing.setElementAt(value.toString(), 0);
    	  row.setName(value.toString());
    	  CategoriesList.saveList(ExpenseIT.categoriesList);
    	break;
      case 1:
    	  int defaultCount = 0;
    	  for(int i = 0; i < ExpenseIT.categoriesList.size(); ++i)
    		  if(((Category)ExpenseIT.categoriesList.get(i)).getIsDefault())
    			  defaultCount++;
    	  if((Boolean) value && defaultCount < 4) {
        	  thing.setElementAt((Boolean)value, 1);
	          row.setIsDefault((Boolean) value);
		      CategoriesList.saveList(ExpenseIT.categoriesList);
		      break;
    	  }
    	  else if(!((Boolean) value)){
        	  thing.setElementAt((Boolean)value, 1);
	          row.setIsDefault((Boolean) value);
		      CategoriesList.saveList(ExpenseIT.categoriesList);
		      break;
    	  }
    		  
    	  else {
    		  JOptionPane.showMessageDialog(null, "Please only select four default Categories");
    		  break;
    	  }	
    }
  }
}*/