/**
 * Date: 3/10/11
 * Programmer: Garry Burns
 * Project Name: ExpenseIT
 * Parent File Names: EditExpense.java, SettingsPane.java
 * Referenced Files: 
 * 
 * Class Version: 1.0
 * Change Log:
 * 03/11/2011	Class Created
 * 
 * Notes: 
 * Settings saves the user settings to a file so they may persist.
 * 
 * Things TODO:
 * 1. Combine all items to be saved into a single file
 */
package com.garryburns.ExpenseIT;

import java.io.*;

class Settings implements Serializable {
 private static final long serialVersionUID = 1L;
 
 private String userName, userPassword, companyName, companyAcct, companyKey, authenticationCode, skin;

 Settings() {
	 userName = "user name";
	 userPassword = "user password";
	 companyName = "Company Name";
	 companyAcct = "Company Account";
	 companyKey = "Company Key";
	 authenticationCode = "personal";
	 skin = "skin";
	 
	 saveSettings(this);
 }
 
 void setUserName(String input) {
	 userName = input;
 }
 void setUserPassword(String input) {
	 userPassword = input;
 }
 void setCompanyName(String input) {
	 companyName = input;
 }
 void setCompanyAcct(String input) {
	 companyAcct = input;
 }
 void setCompanyKey(String input) {
	 companyKey = input;
 }
 void setAuthenticationCode(String input) {
	 authenticationCode = input;
 }
 void setSkin(String input) {
	 skin = input;
 }
 
 
 String getUserName() {
	 return userName;
 }
 String getUserPassword() {
	 return userPassword;
 }
 String getCompanyName() {
	 return companyName;
 }
 String getCompanyAcct() {
	 return companyAcct;
 }
 String getCompanyKey() {
	 return companyKey;
 }
 String getAuthenticationCode() {
	 return authenticationCode;
 }
 String getSkin() {
	 return skin;
 }
 
 static void saveSettings(Settings sets) {
	 try {
		 FileOutputStream fo = new FileOutputStream("ExpenseIT.dat");
		 ObjectOutputStream oo = new ObjectOutputStream(fo);
		 oo.writeObject(sets);
		 oo.close();
	 } catch (IOException e) {
		 System.out.println("Error - " + e.toString());
	 }
 }
 Settings loadSettings() {
	 Settings sets;
	 try {
		 FileInputStream fi = new FileInputStream("ExpenseIT.dat");
		 ObjectInputStream oi = new ObjectInputStream(fi);
		 sets = (Settings) oi.readObject();
		 // TODO add some testing to ensure list is viable
		 oi.close();
		 return sets;
	 } catch (Exception e) {
		 new Settings();
		 System.out.println("Error - " + e.toString());
		 return null;
	 }
 }
}

