/**
 * Date: 3/10/11
 * Programmer: Garry Burns
 * Project Name: ExpenseIT
 * Parent File Names: EditExpense.java
 * Referenced Files: 
 * 			CategoryList.java
 * 
 * Class Version: 0.1
 * Change Log:
 * 03/10/2011	Class Created
 * 
 * Notes: 
 * SettingsPane consists of a menu where mutable options can be adjusted.
 * 
 * Things TODO:
 */
package com.garryburns.ExpenseIT;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

@SuppressWarnings("serial")
public class SettingsPane extends JPanel implements ActionListener {
 JButton jbExitSettings;
 private static JPanel jplHome;
 private static JButton[] jbSettings;
 private static JLabel jlbBanner;
 private static CardLayout cards = new CardLayout();
 private static EditCatsPane jplCatsEditor;
 private static final Dimension buttonSize = new Dimension(270,30);
 private static final int USER = 0, COMP = 1,  SYNC = 2, CAT = 3, LOC = 4, SKIN = 5, SETVERSION =6;
 
 SettingsPane() {
	 super();
	 setLayout(cards);
	 jplHome = new JPanel();
	 jplCatsEditor = new EditCatsPane(); 
	 

	 EditCatsPane.jbBack.addActionListener(this);
	 
	 jlbBanner = new JLabel("Settings");
	 Font f = new Font(Font.DIALOG, Font.BOLD, 15);
	 jlbBanner.setFont(f);
	 jplHome.add(Box.createRigidArea(buttonSize));
	 jplHome.add(jlbBanner);
	 jplHome.add(Box.createRigidArea(buttonSize));
	 
	 loadButtons();
	 
	 add(jplHome, "HOME");
	 add(jplCatsEditor, "CATS");
	 
	 setVisible(true);
 } //End Constructor
 
 @Override
 public void actionPerformed(ActionEvent e) {
	 JButton jbSource = (JButton) e.getSource();
 
	 if(jbSource == EditCatsPane.jbBack){
		 cards.show(this, "HOME");
		 return;
	 }
	 else {
		 int actionCommand = Integer.parseInt(jbSource.getActionCommand());
		 switch (actionCommand) 
		 {
	 		case USER: 
	 				comingSoon();
		 			break; 
		 	case COMP: 
		 			comingSoon();
		 			break;
		 	case SYNC:
		 			comingSoon();
	 				break;
		 	case CAT: 
		 			cards.show(this, "CATS");
		 			break;
		 	case LOC:
		 			comingSoon();
		 			break;
		 	case SKIN:
		 			comingSoon();
		 			break;
		 	case SETVERSION:
		 			askForAuthentication();
		 	default: break;
		 }
	 }
 }
 
 private void comingSoon() {
	JOptionPane.showMessageDialog(getParent(), "This feature is coming soon",
						"Feature Coming Soon",
						JOptionPane.INFORMATION_MESSAGE);	
}

private void askForAuthentication() {
		String input = (String)JOptionPane.showInputDialog(
					getParent(),
					"Please enter your authentication code:"
					+ "\nLite: lite"
					+ "\nPersonal: personal"
					+ "\nProfessional: professional",
					"Upgrade Version",
					JOptionPane.PLAIN_MESSAGE,
					null,
					null,
     				"personal");
		if ((input != null) && (input.length() > 0)) {
			ExpenseIT.settings.setAuthenticationCode(input);
			Settings.saveSettings(ExpenseIT.settings);
			JOptionPane.showMessageDialog(getParent(), "Please restart application for changes to take affect");
         return;
     }
 }
 private String[] setButtonString() {
	 if(ExpenseIT.versionCode.equals("professional")) {
		 String[] buttonNames = {"User Settings", "Company Settings", "Sync Options", "Edit Categories", 
				 				"Saved Locations", "Change Skin", "Upgrade Version"};
		 return buttonNames;
	 }
	 else {
		 String[] buttonNames = {"Edit Categories", "Saved Locations", "Change Skin", "Upgrade Version"}; 
		 return buttonNames;
	 }
 }
 private void loadButtons() {
	 String[] actionCommands = {"0", "1", "2", "3", "4", "5", "6"};
	 String[] buttonNames = setButtonString();
	 jbSettings = new JButton[buttonNames.length];
	 for(int i = 0; i < buttonNames.length; ++i) {
		 jbSettings[i] = new JButton(buttonNames[i]);
		 jbSettings[i].setPreferredSize(buttonSize);
		 if(buttonNames.length == 7)
			 jbSettings[i].setActionCommand(actionCommands[i]);
		 else
			 jbSettings[i].setActionCommand(actionCommands[i+3]);
		 jbSettings[i].addActionListener(this);
		 jplHome.add(jbSettings[i]);
	 }
	 jplHome.add(Box.createRigidArea(new Dimension(300,10)));
	 jbExitSettings = new JButton("Back");
	 jplHome.add(jbExitSettings);
	 
	 if(ExpenseIT.versionCode.equals("lite")) {
		 int j = 0;
		 while(j < buttonNames.length - 1) {
			 jbSettings[j].setEnabled(false);
			 j++;
		 }
	 }
 }
}