/**
 * Date: 3/09/11
 * Programmer: Garry Burns
 * Project Name: ExpenseIT
 * Parent File Names: ExpenseIT.java, AddExpense.java, ExpenseList.java
 * Subfile Names: none
 * 
 * Class Version: 1.0
 * Change Log:
 * 03/09/2011	Class Created
 * 
 * 
 * Notes: 
 * This is essentially a tester class which verifies the date input is in an appropriate
 * format and continues to ask for input if it's not.
 * It also has methods for converting a string to a date and vice versa.
 *  
 * Things TODO:
 * 1. Think of a better name for the class - DateO - I mean seriously, that's horrible!
 */
package com.garryburns.ExpenseIT;

import java.sql.Date;
import java.text.SimpleDateFormat;
import java.util.Calendar;

import javax.swing.JOptionPane;
import javax.swing.JPanel;

@SuppressWarnings("serial")
class DateO extends JPanel {
 static final String DATE_FORMAT_NOW = "MM/dd/yyyy";
 
 static String askForDate() {
	 String dateString;
	 dateString = JOptionPane.showInputDialog(null, 
			   "Date: MM/DD/YYYY or MMDDYY", DateO.today());
	 return dateString;
 }
 
 static Date makeDate(String inputDate) {
	String formattedDate;
	Date date;
  try {
	if(inputDate.length() == 6) {
		formattedDate = ("20" + inputDate.substring(4));
		formattedDate = (formattedDate + "-" + inputDate.substring(0,2));
		formattedDate = (formattedDate + "-" + inputDate.substring(2,4));
		date = Date.valueOf(formattedDate);
		return date;
	}
	else if(inputDate.length() == 8){
		formattedDate = ("20" + inputDate.substring(6));
		formattedDate = (formattedDate + "-" + inputDate.substring(0,2));
		formattedDate = (formattedDate + "-" + inputDate.substring(3,5));
		date = Date.valueOf(formattedDate);
		return date;
	}
	else if(inputDate.length() == 10){
		formattedDate = (inputDate.substring(6));
		formattedDate = (formattedDate + "-" + inputDate.substring(0,2));
		formattedDate = (formattedDate + "-" + inputDate.substring(3,5));
		date = Date.valueOf(formattedDate);
		return date;
	}
	else{
		throw new NumberFormatException();
	}
  } catch (Exception e) {
	  String newInput = JOptionPane.showInputDialog(null,
			  			"Unknown Format Entered\nDate: MM/DD/YYYY", inputDate);
	  date = makeDate(newInput);
	  return date;
	}

 }
 static String makeString(Date inDate) {
	SimpleDateFormat sdf = new SimpleDateFormat(DATE_FORMAT_NOW);
	return sdf.format(inDate);
 }
 static String today() {
	Calendar cal = Calendar.getInstance();
	SimpleDateFormat sdf = new SimpleDateFormat(DATE_FORMAT_NOW);
	return sdf.format(cal.getTime());
 }
 
 /* Testing 
 public static void main(String[] args) {
	 String today = "0d1510";
	 Date date = makeDate(today);
	 System.out.println(date);
	 String output = makeString(date);
	 System.out.println(output);
 }
*/
}

