/**
 * Date: 3/10/11
 * Programmer: Garry Burns
 * Project Name: ExpenseIT
 * Parent File Names: EditExpense.java
 * Referenced Files: 
 * 			CategoryList.java
 * 
 * Class Version: 0.1
 * Change Log:
 * 03/10/2011	Class Created
 * 
 * Notes: 
 * SettingsPane consists of a menu where mutable options can be adjusted.
 * 
 * Things TODO:
 */
package com.garryburns.ExpenseIT;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

@SuppressWarnings("serial")
public class SettingsPane extends JPanel implements ActionListener {
 JButton jbExitSettings;
 private static JPanel jplHome;
 private static JButton[] jbSettings;
 private static JLabel jlbBanner;
 private static CardLayout cards = new CardLayout();
 private static EditCatsPane jplCatsEditor;
 private static EditLocsPane jplLocsEditor;
 private static final Dimension buttonSize = new Dimension(270,30);
 private static final int USER = 0, SYNC = 1, CAT = 2, LOC = 3, SKIN = 4, 
 							SETVERSION = 5, ABOUT = 6;
 private Frame parent;
 SettingsPane(Frame inParent) {
	 super();
	 setLayout(cards);
	 parent = inParent;
	 jplHome = new JPanel();
	 jplCatsEditor = new EditCatsPane();
	 jplLocsEditor = new EditLocsPane();
	 

	 EditCatsPane.jbBack.addActionListener(this);
	 EditLocsPane.jbBack.addActionListener(this);
	 
	 jlbBanner = new JLabel("Settings");
	 Font f = new Font(Font.DIALOG, Font.BOLD, 15);
	 jlbBanner.setFont(f);
	 jplHome.add(Box.createRigidArea(buttonSize));
	 jplHome.add(jlbBanner);
	 jplHome.add(Box.createRigidArea(buttonSize));
	 
	 loadButtons();
	 
	 add(jplHome, "HOME");
	 add(jplCatsEditor, "CATS");
	 add(jplLocsEditor, "LOCS");
	 
	 setVisible(true);
 } //End Constructor
 
 @Override
 public void actionPerformed(ActionEvent e) {
	 JButton jbSource = (JButton) e.getSource();
 
	 if(jbSource.getText().equals("Back")){
		 cards.show(this, "HOME");
		 return;
	 }
	 else {
		 int actionCommand = Integer.parseInt(jbSource.getActionCommand());
		 switch (actionCommand) 
		 {
	 		case USER: 
	 				userSettings();
		 			break; 
		 	case SYNC:
		 			comingSoon();
	 				break;
		 	case CAT: 
		 			cards.show(this, "CATS");
		 			break;
		 	case LOC:
		 			jplLocsEditor.enableDelete();
		 			cards.show(this, "LOCS");
		 			break;
		 	case SKIN:
		 			comingSoon();
		 			break;
		 	case SETVERSION:
		 			askForAuthentication();
		 			break;
		 	case ABOUT:
		 			showAbout();
		 			break;
		 	default: break;
		 }
	 }
 }
 
private void showAbout() {
	JOptionPane.showMessageDialog(getParent(), ExpenseIT.aboutMe, "About", JOptionPane.INFORMATION_MESSAGE);
}

 private void userSettings() {
	CustomDialog user = new CustomDialog(parent);
	user.pack();
	user.setLocationRelativeTo(this);
	user.setVisible(true);
 }
 private void comingSoon() {
	JOptionPane.showMessageDialog(getParent(), "This feature is coming soon",
						"Feature Coming Soon",
						JOptionPane.INFORMATION_MESSAGE);	
 }

 private void askForAuthentication() {
	Font f = new Font(Font.SANS_SERIF, Font.ITALIC, 12);
	String msg = "Please enter your authentication code:";
	JLabel tester = new JLabel("Lite: lite  Personal: personal  Professional: professional");
	tester.setFont(f);
	Object[] array = {msg, tester};
	String input = (String)JOptionPane.showInputDialog(
					getParent(),
					array,
					"Upgrade Version",
					JOptionPane.PLAIN_MESSAGE,
					null,
					null,
     				"personal");
	if ((input != null) && (input.length() > 0)) {
		ExpenseIT.settings.setAuthenticationCode(input);
		Settings.saveSettings(ExpenseIT.settings);
		JOptionPane.showMessageDialog(getParent(), "Please restart application for changes to take affect");
        return;
	}
 }
 private String[] setButtonString() {
	 if(ExpenseIT.versionCode.equals("professional")) {
		 String[] names = {"User Settings", "Sync Options", "Edit Categories", 
				 				"Saved Locations", "Change Skin", "Upgrade Version", "About"};
		 return names;
	 }
	 else {
		 String[] names = {"Edit Categories", "Saved Locations", "Change Skin", "Upgrade Version", "About"}; 
		 return names;
	 }
 }
 private void loadButtons() {
	 String[] actionCommands = {"0", "1", "2", "3", "4", "5", "6"};
	 String[] buttonNames = setButtonString();
	 jbSettings = new JButton[buttonNames.length];
	 for(int i = 0; i < buttonNames.length; ++i) {
		 jbSettings[i] = new JButton(buttonNames[i]);
		 jbSettings[i].setPreferredSize(buttonSize);
		 if(buttonNames.length == 7)
			 jbSettings[i].setActionCommand(actionCommands[i]);
		 else
			 jbSettings[i].setActionCommand(actionCommands[i+2]);
		 jbSettings[i].addActionListener(this);
		 jplHome.add(jbSettings[i]);
	 }
	 jplHome.add(Box.createRigidArea(new Dimension(300,15)));
	 jbExitSettings = new JButton("Back");
	 jplHome.add(jbExitSettings);
	 
	 if(ExpenseIT.versionCode.equals("lite")) {
		 int j = 0;
		 while(j < buttonNames.length - 2) {
			 jbSettings[j].setEnabled(false);
			 j++;
		 }
	 }
 }
}